diff --git a/libpurple/purplenotification.h b/libpurple/purplenotification.h
--- a/libpurple/purplenotification.h
+++ b/libpurple/purplenotification.h
@@ -29,6 +29,7 @@
 #include "purpleaccount.h"
 #include "purpleauthorizationrequest.h"
 #include "purpleaddcontactrequest.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -37,6 +38,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0.
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef enum {
     PURPLE_NOTIFICATION_TYPE_UNKNOWN,
     PURPLE_NOTIFICATION_TYPE_GENERIC,
@@ -58,6 +60,8 @@ typedef enum {
  */
 
 #define PURPLE_TYPE_NOTIFICATION (purple_notification_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleNotification, purple_notification, PURPLE,
                      NOTIFICATION, GObject)
 
@@ -78,6 +82,7 @@ G_DECLARE_FINAL_TYPE(PurpleNotification,
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleNotification *purple_notification_new(PurpleNotificationType type, PurpleAccount *account, gpointer data, GDestroyNotify data_destroy_func);
 
 /**
@@ -92,6 +97,7 @@ PurpleNotification *purple_notification_
  *
  * Since: 3.0.0.
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleNotification *purple_notification_new_from_add_contact_request(PurpleAddContactRequest *request);
 
 /**
@@ -107,6 +113,7 @@ PurpleNotification *purple_notification_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleNotification *purple_notification_new_from_authorization_request(PurpleAuthorizationRequest *authorization_request);
 
 /**
@@ -122,6 +129,7 @@ PurpleNotification *purple_notification_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleNotification *purple_notification_new_from_connection_error(PurpleAccount *account, PurpleConnectionErrorInfo *info);
 
 /**
@@ -134,6 +142,7 @@ PurpleNotification *purple_notification_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_notification_get_id(PurpleNotification *notification);
 
 /**
@@ -146,6 +155,7 @@ const gchar *purple_notification_get_id(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleNotificationType purple_notification_get_notification_type(PurpleNotification *notification);
 
 /**
@@ -158,6 +168,7 @@ PurpleNotificationType purple_notificati
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_notification_get_account(PurpleNotification *notification);
 
 /**
@@ -170,6 +181,7 @@ PurpleAccount *purple_notification_get_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_notification_get_created_timestamp(PurpleNotification *notification);
 
 /**
@@ -186,6 +198,7 @@ GDateTime *purple_notification_get_creat
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_set_created_timestamp(PurpleNotification *notification, GDateTime *timestamp);
 
 /**
@@ -198,6 +211,7 @@ void purple_notification_set_created_tim
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_notification_get_title(PurpleNotification *notification);
 
 /**
@@ -209,6 +223,7 @@ const gchar *purple_notification_get_tit
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_set_title(PurpleNotification *notification, const gchar *title);
 
 /**
@@ -221,6 +236,7 @@ void purple_notification_set_title(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_notification_get_icon_name(PurpleNotification *notification);
 
 /**
@@ -232,6 +248,7 @@ const gchar *purple_notification_get_ico
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_set_icon_name(PurpleNotification *notification, const gchar *icon_name);
 
 /**
@@ -244,6 +261,7 @@ void purple_notification_set_icon_name(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_notification_get_read(PurpleNotification *notification);
 
 /**
@@ -255,6 +273,7 @@ gboolean purple_notification_get_read(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_set_read(PurpleNotification *notification, gboolean read);
 
 /**
@@ -267,6 +286,7 @@ void purple_notification_set_read(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_notification_get_interactive(PurpleNotification *notification);
 
 /**
@@ -278,6 +298,7 @@ gboolean purple_notification_get_interac
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_set_interactive(PurpleNotification *notification, gboolean interactive);
 
 /**
@@ -290,6 +311,7 @@ void purple_notification_set_interactive
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer purple_notification_get_data(PurpleNotification *notification);
 
 /**
@@ -305,6 +327,7 @@ gpointer purple_notification_get_data(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gint purple_notification_compare(gconstpointer a, gconstpointer b);
 
 /**
@@ -319,6 +342,7 @@ gint purple_notification_compare(gconstp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_delete(PurpleNotification *notification);
 
 G_END_DECLS
diff --git a/libpurple/purplenotificationmanager.h b/libpurple/purplenotificationmanager.h
--- a/libpurple/purplenotificationmanager.h
+++ b/libpurple/purplenotificationmanager.h
@@ -28,10 +28,13 @@
 
 #include "purpleaccount.h"
 #include "purplenotification.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_NOTIFICATION_MANAGER (purple_notification_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleNotificationManager, purple_notification_manager,
                      PURPLE, NOTIFICATION_MANAGER, GObject)
 
@@ -53,6 +56,7 @@ G_DECLARE_FINAL_TYPE(PurpleNotificationM
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleNotificationManager *purple_notification_manager_get_default(void);
 
 /**
@@ -64,6 +68,7 @@ PurpleNotificationManager *purple_notifi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_notification_manager_get_default_as_model(void);
 
 /**
@@ -75,6 +80,7 @@ GListModel *purple_notification_manager_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_manager_add(PurpleNotificationManager *manager, PurpleNotification *notification);
 
 /**
@@ -86,6 +92,7 @@ void purple_notification_manager_add(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_manager_remove(PurpleNotificationManager *manager, PurpleNotification *notification);
 
 /**
@@ -103,6 +110,7 @@ void purple_notification_manager_remove(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_manager_remove_with_account(PurpleNotificationManager *manager, PurpleAccount *account, gboolean all);
 
 /**
@@ -115,6 +123,7 @@ void purple_notification_manager_remove_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint purple_notification_manager_get_unread_count(PurpleNotificationManager *manager);
 
 /**
@@ -125,6 +134,7 @@ guint purple_notification_manager_get_un
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_notification_manager_clear(PurpleNotificationManager *manager);
 
 G_END_DECLS
diff --git a/libpurple/purpleperson.h b/libpurple/purpleperson.h
--- a/libpurple/purpleperson.h
+++ b/libpurple/purpleperson.h
@@ -28,10 +28,13 @@
 
 #include "purpleavatar.h"
 #include "purpletags.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_PERSON (purple_person_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurplePerson, purple_person, PURPLE, PERSON, GObject)
 
 #include "purplecontactinfo.h"
@@ -54,6 +57,7 @@ G_DECLARE_FINAL_TYPE(PurplePerson, purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePerson *purple_person_new(void);
 
 /**
@@ -66,6 +70,7 @@ PurplePerson *purple_person_new(void);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_person_get_id(PurplePerson *person);
 
 /**
@@ -80,6 +85,7 @@ const char *purple_person_get_id(PurpleP
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_person_get_alias(PurplePerson *person);
 
 /**
@@ -97,6 +103,7 @@ const char *purple_person_get_alias(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_person_set_alias(PurplePerson *person, const char *alias);
 
 /**
@@ -112,6 +119,7 @@ void purple_person_set_alias(PurplePerso
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAvatar *purple_person_get_avatar_for_display(PurplePerson *person);
 
 /**
@@ -124,6 +132,7 @@ PurpleAvatar *purple_person_get_avatar_f
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAvatar *purple_person_get_avatar(PurplePerson *person);
 
 /**
@@ -140,6 +149,7 @@ PurpleAvatar *purple_person_get_avatar(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_person_set_avatar(PurplePerson *person, PurpleAvatar *avatar);
 
 /**
@@ -152,6 +162,7 @@ void purple_person_set_avatar(PurplePers
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_person_get_color(PurplePerson *person);
 
 /**
@@ -164,6 +175,7 @@ const char *purple_person_get_color(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_person_set_color(PurplePerson *person, const char *color);
 
 /**
@@ -178,6 +190,7 @@ void purple_person_set_color(PurplePerso
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_person_get_color_for_display(PurplePerson *person);
 
 /**
@@ -190,6 +203,7 @@ const char *purple_person_get_color_for_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTags *purple_person_get_tags(PurplePerson *person);
 
 /**
@@ -203,6 +217,7 @@ PurpleTags *purple_person_get_tags(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_person_get_name_for_display(PurplePerson *person);
 
 /**
@@ -217,6 +232,7 @@ const char *purple_person_get_name_for_d
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_person_add_contact_info(PurplePerson *person, PurpleContactInfo *info);
 
 /**
@@ -230,6 +246,7 @@ void purple_person_add_contact_info(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_person_remove_contact_info(PurplePerson *person, PurpleContactInfo *info);
 
 /**
@@ -243,6 +260,7 @@ gboolean purple_person_remove_contact_in
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_person_get_priority_contact_info(PurplePerson *person);
 
 /*
@@ -255,6 +273,7 @@ PurpleContactInfo *purple_person_get_pri
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_person_has_contacts(PurplePerson *person);
 
 /**
@@ -272,6 +291,7 @@ gboolean purple_person_has_contacts(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_person_matches(PurplePerson *person, const char *needle);
 
 G_END_DECLS
diff --git a/libpurple/purpleplugininfo.h b/libpurple/purpleplugininfo.h
--- a/libpurple/purpleplugininfo.h
+++ b/libpurple/purpleplugininfo.h
@@ -30,6 +30,8 @@
 #include <gplugin.h>
 #include <gplugin-native.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_PLUGIN_INFO (purple_plugin_info_get_type())
 
 /**
@@ -41,6 +43,7 @@
  * Since: 3.0.0
  */
 
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurplePluginInfo, purple_plugin_info, PURPLE,
                          PLUGIN_INFO, GPluginPluginInfo)
 
@@ -200,6 +203,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GPluginPluginInfo *purple_plugin_info_new(const char *first_property, ...) G_GNUC_NULL_TERMINATED;
 
 /**
@@ -212,6 +216,7 @@ GPluginPluginInfo *purple_plugin_info_ne
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePluginInfoFlags purple_plugin_info_get_flags(PurplePluginInfo *info);
 
 /**
@@ -225,6 +230,7 @@ PurplePluginInfoFlags purple_plugin_info
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_plugin_info_get_error(PurplePluginInfo *info);
 
 /**
@@ -237,6 +243,7 @@ const gchar *purple_plugin_info_get_erro
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_plugin_info_get_unloaded(PurplePluginInfo *info);
 
 /**
@@ -248,6 +255,7 @@ gboolean purple_plugin_info_get_unloaded
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_plugin_info_set_unloaded(PurplePluginInfo *info, gboolean unloaded);
 
 /**
@@ -260,6 +268,7 @@ void purple_plugin_info_set_unloaded(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GActionGroup *purple_plugin_info_get_action_group(PurplePluginInfo *info);
 
 /**
@@ -272,6 +281,7 @@ GActionGroup *purple_plugin_info_get_act
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GMenuModel *purple_plugin_info_get_action_menu(PurplePluginInfo *info);
 
 G_END_DECLS
diff --git a/libpurple/purplepresence.h b/libpurple/purplepresence.h
--- a/libpurple/purplepresence.h
+++ b/libpurple/purplepresence.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 /**
  * PurplePresence:
  *
@@ -73,6 +75,7 @@ typedef struct _PurplePresence PurplePre
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef enum {
 	PURPLE_PRESENCE_PRIMITIVE_OFFLINE,
 	PURPLE_PRESENCE_PRIMITIVE_AVAILABLE,
@@ -117,6 +120,7 @@ G_DECLARE_DERIVABLE_TYPE(PurplePresence,
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePresence *purple_presence_new(void);
 
 /**
@@ -292,6 +296,7 @@ GDateTime *purple_presence_get_login_tim
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gint purple_presence_compare(PurplePresence *presence1, PurplePresence *presence2);
 
 /**
@@ -304,6 +309,7 @@ gint purple_presence_compare(PurplePrese
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePresencePrimitive purple_presence_get_primitive(PurplePresence *presence);
 
 /**
@@ -315,6 +321,7 @@ PurplePresencePrimitive purple_presence_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_presence_set_primitive(PurplePresence *presence, PurplePresencePrimitive primitive);
 
 /**
@@ -327,6 +334,7 @@ void purple_presence_set_primitive(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_presence_get_message(PurplePresence *presence);
 
 /**
@@ -338,6 +346,7 @@ const char *purple_presence_get_message(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_presence_set_message(PurplePresence *presence, const char *message);
 
 /**
@@ -350,6 +359,7 @@ void purple_presence_set_message(PurpleP
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_presence_get_emoji(PurplePresence *presence);
 
 /**
@@ -362,6 +372,7 @@ const char *purple_presence_get_emoji(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_presence_set_emoji(PurplePresence *presence, const char *emoji);
 
 /**
@@ -374,6 +385,7 @@ void purple_presence_set_emoji(PurplePre
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_presence_get_mobile(PurplePresence *presence);
 
 /**
@@ -385,6 +397,7 @@ gboolean purple_presence_get_mobile(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_presence_set_mobile(PurplePresence *presence, gboolean mobile);
 
 /**
@@ -397,6 +410,7 @@ void purple_presence_set_mobile(PurplePr
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_presence_get_notifications_disabled(PurplePresence *presence);
 
 /**
@@ -408,6 +422,7 @@ gboolean purple_presence_get_notificatio
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_presence_set_notifications_disabled(PurplePresence *presence, gboolean notifications_disabled);
 
 /**
@@ -421,6 +436,7 @@ void purple_presence_set_notifications_d
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_presence_primitive_to_string(PurplePresencePrimitive primitive);
 
 G_END_DECLS
diff --git a/libpurple/purplepresencemanager.h b/libpurple/purplepresencemanager.h
--- a/libpurple/purplepresencemanager.h
+++ b/libpurple/purplepresencemanager.h
@@ -31,10 +31,13 @@
 #include <glib-object.h>
 
 #include "purplesavedpresence.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_PRESENCE_MANAGER purple_presence_manager_get_type()
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurplePresenceManager, purple_presence_manager, PURPLE,
                      PRESENCE_MANAGER, GObject)
 
@@ -58,6 +61,7 @@ G_DECLARE_FINAL_TYPE(PurplePresenceManag
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePresenceManager *purple_presence_manager_new(const char *filename);
 
 /**
@@ -71,6 +75,7 @@ PurplePresenceManager *purple_presence_m
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_presence_manager_get_filename(PurplePresenceManager *manager);
 
 /**
@@ -84,6 +89,7 @@ const char *purple_presence_manager_get_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleSavedPresence *purple_presence_manager_get_active(PurplePresenceManager *manager);
 
 /**
@@ -102,6 +108,7 @@ PurpleSavedPresence *purple_presence_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_presence_manager_set_active(PurplePresenceManager *manager, const char *id);
 
 /**
@@ -118,6 +125,7 @@ gboolean purple_presence_manager_set_act
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleSavedPresence *purple_presence_manager_create(PurplePresenceManager *manager);
 
 /**
@@ -133,6 +141,7 @@ PurpleSavedPresence *purple_presence_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_presence_manager_remove(PurplePresenceManager *manager, const char *id);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocol.h b/libpurple/purpleprotocol.h
--- a/libpurple/purpleprotocol.h
+++ b/libpurple/purpleprotocol.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_PROTOCOL (purple_protocol_get_type())
 
 /**
@@ -40,6 +42,7 @@
  * Since: 3.0.0
  */
 
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleProtocol, purple_protocol, PURPLE, PROTOCOL,
                          GObject)
 
@@ -183,6 +186,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_get_id(PurpleProtocol *protocol);
 
 /**
@@ -195,6 +199,7 @@ const gchar *purple_protocol_get_id(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_get_name(PurpleProtocol *protocol);
 
 /**
@@ -207,6 +212,7 @@ const gchar *purple_protocol_get_name(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_get_description(PurpleProtocol *protocol);
 
 /**
@@ -219,6 +225,7 @@ const gchar *purple_protocol_get_descrip
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocolOptions purple_protocol_get_options(PurpleProtocol *protocol);
 
 /**
@@ -232,6 +239,7 @@ PurpleProtocolOptions purple_protocol_ge
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_protocol_get_user_splits(PurpleProtocol *protocol);
 
 /**
@@ -245,6 +253,7 @@ GList *purple_protocol_get_user_splits(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_protocol_get_account_options(PurpleProtocol *protocol);
 
 /**
@@ -257,6 +266,7 @@ GList *purple_protocol_get_account_optio
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddyIconSpec *purple_protocol_get_icon_spec(PurpleProtocol *protocol);
 
 /**
@@ -269,6 +279,7 @@ PurpleBuddyIconSpec *purple_protocol_get
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleWhiteboardOps *purple_protocol_get_whiteboard_ops(PurpleProtocol *protocol);
 
 /**
@@ -280,6 +291,7 @@ PurpleWhiteboardOps *purple_protocol_get
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_login(PurpleProtocol *protocol, PurpleAccount *account);
 
 /**
@@ -291,6 +303,7 @@ void purple_protocol_login(PurpleProtoco
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_close(PurpleProtocol *protocol, PurpleConnection *connection);
 
 /**
@@ -308,6 +321,7 @@ void purple_protocol_close(PurpleProtoco
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_can_connect_async(PurpleProtocol *protocol, PurpleAccount *account, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -323,6 +337,7 @@ void purple_protocol_can_connect_async(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_can_connect_finish(PurpleProtocol *protocol, GAsyncResult *result, GError **error);
 
 
@@ -342,6 +357,7 @@ gboolean purple_protocol_can_connect_fin
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConnection *purple_protocol_create_connection(PurpleProtocol *protocol, PurpleAccount *account, const char *password, GError **error);
 
 /**
@@ -356,6 +372,7 @@ PurpleConnection *purple_protocol_create
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_protocol_get_status_types(PurpleProtocol *protocol, PurpleAccount *account);
 
 /**
@@ -370,6 +387,7 @@ GList *purple_protocol_get_status_types(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_get_icon_name(PurpleProtocol *protocol);
 
 /**
@@ -388,6 +406,7 @@ const gchar *purple_protocol_get_icon_na
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_get_icon_search_path(PurpleProtocol *protocol);
 
 /**
@@ -406,6 +425,7 @@ const gchar *purple_protocol_get_icon_se
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_get_icon_resource_path(PurpleProtocol *protocol);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolactions.h b/libpurple/purpleprotocolactions.h
--- a/libpurple/purpleprotocolactions.h
+++ b/libpurple/purpleprotocolactions.h
@@ -32,8 +32,11 @@
 
 #include "connection.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_ACTIONS (purple_protocol_actions_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolActions, purple_protocol_actions, PURPLE,
                     PROTOCOL_ACTIONS, PurpleProtocol)
 
@@ -91,6 +94,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_actions_get_prefix(PurpleProtocolActions *actions);
 
 /**
@@ -104,6 +108,7 @@ const gchar *purple_protocol_actions_get
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GActionGroup *purple_protocol_actions_get_action_group(PurpleProtocolActions *actions, PurpleConnection *connection);
 
 /**
@@ -117,6 +122,7 @@ GActionGroup *purple_protocol_actions_ge
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GMenu *purple_protocol_actions_get_menu(PurpleProtocolActions *actions, PurpleConnection *connection);
 
 /**
@@ -130,6 +136,7 @@ GMenu *purple_protocol_actions_get_menu(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_actions_changed(PurpleProtocolActions *actions, PurpleAccount *account);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolchat.h b/libpurple/purpleprotocolchat.h
--- a/libpurple/purpleprotocolchat.h
+++ b/libpurple/purpleprotocolchat.h
@@ -33,6 +33,7 @@
 #include "connection.h"
 #include "purplemessage.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_CHAT (purple_protocol_chat_get_type())
 
@@ -44,6 +45,7 @@
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolChat, purple_protocol_chat, PURPLE,
                     PROTOCOL_CHAT, PurpleProtocol)
 
@@ -146,6 +148,7 @@ struct _PurpleProtocolChatInterface {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_protocol_chat_info(PurpleProtocolChat *protocol_chat, PurpleConnection *connection);
 
 /**
@@ -162,6 +165,7 @@ GList *purple_protocol_chat_info(PurpleP
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GHashTable *purple_protocol_chat_info_defaults(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, const gchar *chat_name);
 
 /**
@@ -175,6 +179,7 @@ GHashTable *purple_protocol_chat_info_de
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_chat_join(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, GHashTable *components);
 
 /**
@@ -188,6 +193,7 @@ void purple_protocol_chat_join(PurplePro
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_chat_reject(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, GHashTable *components);
 
 /**
@@ -202,6 +208,7 @@ void purple_protocol_chat_reject(PurpleP
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *purple_protocol_chat_get_name(PurpleProtocolChat *protocol_chat, GHashTable *components);
 
 /**
@@ -216,6 +223,7 @@ gchar *purple_protocol_chat_get_name(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_chat_invite(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, gint id, const gchar *message, const gchar *who);
 
 /**
@@ -228,6 +236,7 @@ void purple_protocol_chat_invite(PurpleP
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_chat_leave(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, gint id);
 
 /**
@@ -244,6 +253,7 @@ void purple_protocol_chat_leave(PurplePr
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gint purple_protocol_chat_send(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, gint id, PurpleConversation *conversation, PurpleMessage *message);
 
 /**
@@ -259,6 +269,7 @@ gint purple_protocol_chat_send(PurplePro
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *purple_protocol_chat_get_user_real_name(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, gint id, const gchar *who);
 
 /**
@@ -272,6 +283,7 @@ gchar *purple_protocol_chat_get_user_rea
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_chat_set_topic(PurpleProtocolChat *protocol_chat, PurpleConnection *connection, gint id, const gchar *topic);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolclient.h b/libpurple/purpleprotocolclient.h
--- a/libpurple/purpleprotocolclient.h
+++ b/libpurple/purpleprotocolclient.h
@@ -33,6 +33,7 @@
 #include "purpleaccount.h"
 #include "connection.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_CLIENT (purple_protocol_client_get_type())
 G_DECLARE_INTERFACE(PurpleProtocolClient, purple_protocol_client, PURPLE,
@@ -148,6 +149,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_protocol_client_list_emblem(PurpleProtocolClient *client, PurpleBuddy *buddy);
 
 /**
@@ -163,6 +165,7 @@ const gchar *purple_protocol_client_list
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_protocol_client_blist_node_menu(PurpleProtocolClient *client, PurpleBlistNode *node);
 
 /**
@@ -174,6 +177,7 @@ GList *purple_protocol_client_blist_node
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_client_buddy_free(PurpleProtocolClient *client, PurpleBuddy *buddy);
 
 /**
@@ -186,6 +190,7 @@ void purple_protocol_client_buddy_free(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_client_convo_closed(PurpleProtocolClient *client, PurpleConnection *connection, const gchar *who);
 
 /**
@@ -202,9 +207,10 @@ void purple_protocol_client_convo_closed
  *
  * Since: 3.0.0
  *
- * Deprecated: 3.0.0: This should use purple_protcol_client_normalize_name when
+ * Deprecated: 3.0.0: This should use purple_protocol_client_normalize_name when
  *             it is created which will return an allocated value.
  */
+PURPLE_DEPRECATED
 const gchar *purple_protocol_client_normalize(PurpleProtocolClient *client, PurpleAccount *account, const gchar *who);
 
 /**
@@ -220,6 +226,7 @@ const gchar *purple_protocol_client_norm
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleChat *purple_protocol_client_find_blist_chat(PurpleProtocolClient *client, PurpleAccount *account, const gchar *name);
 
 /**
@@ -233,6 +240,7 @@ PurpleChat *purple_protocol_client_find_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_protocol_client_offline_message(PurpleProtocolClient *client, PurpleBuddy *buddy);
 
 /**
@@ -252,6 +260,7 @@ gboolean purple_protocol_client_offline_
  * Deprecated: 3.0.0: This is a premature optimization. Right now this is only
  *             used by GaduGadu for a single item and should be replaced.
  */
+PURPLE_DEPRECATED
 GHashTable *purple_protocol_client_get_account_text_table(PurpleProtocolClient *client, PurpleAccount *account);
 
 /**
@@ -266,6 +275,7 @@ GHashTable *purple_protocol_client_get_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gssize purple_protocol_client_get_max_message_size(PurpleProtocolClient *client, PurpleConversation *conv);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolcontacts.h b/libpurple/purpleprotocolcontacts.h
--- a/libpurple/purpleprotocolcontacts.h
+++ b/libpurple/purpleprotocolcontacts.h
@@ -31,8 +31,11 @@
 #include <glib-object.h>
 
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_PROTOCOL_CONTACTS (purple_protocol_contacts_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolContacts,
                     purple_protocol_contacts, PURPLE,
                     PROTOCOL_CONTACTS, PurpleProtocol)
@@ -87,6 +90,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_contacts_get_profile_async(PurpleProtocolContacts *protocol_contacts, PurpleContactInfo *info, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -104,6 +108,7 @@ void purple_protocol_contacts_get_profil
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 char *purple_protocol_contacts_get_profile_finish(PurpleProtocolContacts *protocol_contacts, GAsyncResult *result, GError **error);
 
 /**
@@ -118,6 +123,7 @@ char *purple_protocol_contacts_get_profi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GActionGroup *purple_protocol_contacts_get_actions(PurpleProtocolContacts *protocol_contacts, PurpleContactInfo *info);
 
 /**
@@ -134,6 +140,7 @@ GActionGroup *purple_protocol_contacts_g
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GMenuModel *purple_protocol_contacts_get_menu(PurpleProtocolContacts *protocol_contacts, PurpleContactInfo *info);
 
 G_END_DECLS
diff --git a/libpurple/purpleprotocolcontactsearch.h b/libpurple/purpleprotocolcontactsearch.h
--- a/libpurple/purpleprotocolcontactsearch.h
+++ b/libpurple/purpleprotocolcontactsearch.h
@@ -31,14 +31,19 @@
 #include <glib-object.h>
 
 #include "purpleprotocol.h"
+#include "purpleversion.h"
+
+#define PURPLE_PROTOCOL_CONTACT_SEARCH_DOMAIN \
+	g_quark_from_static_string("purple-protocol-contact-search") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 #define PURPLE_TYPE_PROTOCOL_CONTACT_SEARCH (purple_protocol_contact_search_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_INTERFACE(PurpleProtocolContactSearch,
                     purple_protocol_contact_search, PURPLE,
                     PROTOCOL_CONTACT_SEARCH, PurpleProtocol)
 
-#define PURPLE_PROTOCOL_CONTACT_SEARCH_DOMAIN (g_quark_from_static_string("purple-protocol-contact-search"))
-
 /**
  * PurpleProtocolContactSearch:
  *
@@ -87,6 +92,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_contact_search_search_async(PurpleProtocolContactSearch *search, PurpleAccount *account, const char *text, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -104,6 +110,7 @@ void purple_protocol_contact_search_sear
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_protocol_contact_search_search_finish(PurpleProtocolContactSearch *search, GAsyncResult *result, GError **error);
 
 G_END_DECLS
